//-----------------------------------------------------------------------------
// dropdown list TCYݒp
// Copyright (c) 2008  N099
//-----------------------------------------------------------------------------
#include <windows.h>
#include <tchar.h>
#include <strsafe.h>
#include <stddef.h>

#include "filter.h"
#include "ddbox.h"

//static function prototypes
static BOOL get_size_from_edit(HWND hdb, int *x, int *y);
static void ins_size_list(HWND hdb, int x, int y, BOOL sel);
static void load_size_list(HWND hdb, FILTER *fp);
static void save_size_list(HWND hdb, FILTER *fp);
static void get_font(void);
static void subclass_edit(void);
static void clear_handle(void);
static LRESULT CALLBACK ddb_edit_proc(HWND h, UINT m, WPARAM w, LPARAM l);

//handles
static HWND h_btn, h_ddbox, h_edit;
static HFONT h_font;
static WNDPROC orig_edit_proc = NULL;

//layout (in pixel)
#define WBTN 44 /* set{^ */
#define SPC0  8 /* `FbN{bNXƃ{^ */
#define SPC1  4 /* {^ƃXg{bNX */
#define SPC2  2 /* Xg{bNXƉE[ */

BOOL ddbox_init(HWND hwnd, FILTER *fp, LPCSTR name)
{
    int px,pw,ph;
    RECT rcp,rcc;
    POINT pt;
    
    //I[o[Ch`FbN{bNX擾
    HWND hchb = FindWindowExA(hwnd, NULL, "BUTTON", name);
    if(!hchb){
        return FALSE;
    }
    
    //`FbN{bNX̌㔼u
    GetClientRect(hwnd, &rcp);
    GetWindowRect(hchb, &rcc);

    pt.x = rcc.left;
    pt.y = rcc.top;
    ScreenToClient(hwnd, &pt);

    //TCY𔼕ɂ
    pw = rcp.right - rcp.left;
    ph = rcc.bottom - rcc.top;
    px = pt.x + pw/2 + SPC0;
    MoveWindow(hchb, pt.x, pt.y, pw/2, ph, 1);

    clear_handle();
    get_font();
    
    //ɈU{bNX쐬č߂
    h_ddbox = CreateWindow(TEXT("COMBOBOX"), TEXT(""),
                           CBS_DROPDOWN | WS_CHILD | WS_VISIBLE,
                           px + WBTN + SPC1, pt.y, pw - px, ph * NUM_LIST_MAX,
                           hwnd, NULL, fp->dll_hinst, NULL);
    if(!h_ddbox){
        return FALSE;
    }
    SendMessage(h_ddbox, CB_LIMITTEXT, 10, 0);
    SendMessage(h_ddbox, WM_SETFONT, (WPARAM)h_font, FALSE);
    
    //Xgvf̏
    load_size_list(h_ddbox, fp);

    //GfBbg̈TuNX
    subclass_edit();

    //R{{bNX̍ƈʒuvZ
    GetWindowRect(h_ddbox, &rcc);
    ph = rcc.bottom - rcc.top;
    pt.y = rcp.bottom - ph - 1; //1pix̗]T

    //Zbg{^쐬
    h_btn = CreateWindow(TEXT("BUTTON"), TEXT("set->"),
                         WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,
                         px, pt.y + 1, WBTN, ph - 2,
                         hwnd, (HMENU)IDC_SETSIZE, fp->dll_hinst, NULL);
    if(!h_btn){
        return FALSE;
    }
    SendMessage(h_btn, WM_SETFONT, (WPARAM)h_font, TRUE);
    px += WBTN + SPC1;

    //R{{bNXړ
    MoveWindow(h_ddbox, px, pt.y, pw - px - SPC2, ph, 1);
    
    return TRUE;
}

BOOL ddbox_exit(HWND hwnd, FILTER *fp)
{
    if(h_edit && orig_edit_proc){
        SetWindowLongPtr(h_edit, GWL_WNDPROC, (LONG_PTR)orig_edit_proc);
    }
    
    if(h_ddbox){
        save_size_list(h_ddbox, fp);
    }
    
    if(h_font){
        DeleteObject(h_font);
    }
    
    //clear
    clear_handle();
    return TRUE;
}

BOOL ddbox_get_size(POINT *pp)
{
    int x = 0, y = 0;
    LRESULT idx;

    if(!pp || !h_ddbox){
        return FALSE;
    }
    
    idx = SendMessage(h_ddbox, CB_GETCURSEL, 0, 0);
    if(idx != CB_ERR){ //Iς
        LRESULT r = SendMessage(h_ddbox, CB_GETITEMDATA, idx, 0);
        if(r != CB_ERR){
            x = LOWORD(r);
            y = HIWORD(r);
        }
    }else{ //I
        int xtmp,ytmp;
        if(get_size_from_edit(h_ddbox, &xtmp, &ytmp)){
            x = xtmp;
            y = ytmp;
            ins_size_list(h_ddbox, x, y, TRUE);
        }
    }
    
    if(x && y){
        pp->x = x;
        pp->y = y;
        return TRUE;
    }else{
        return FALSE;
    }
}

//static functions

BOOL get_size_from_edit(HWND hdb, int *x, int *y)
{
    int i;
    TCHAR buf[64];
    LRESULT lr = SendMessage(hdb, WM_GETTEXT, ARRAYSIZE(buf), (LPARAM)buf); 
    buf[lr] = TEXT('\0');
    
    for(i=0; i<lr; ++i){
        if(!_istdigit(buf[i])) buf[i] = TEXT(' ');
    }
    
    if(2 == _stscanf_s(buf, TEXT("%d %d"), x, y)){
        //Nbv
        *x = max(min(*x, 9999), 32);
        *y = max(min(*y, 9999), 32);
        
        //\̍XV
        StringCbPrintf(buf, sizeof(buf), TEXT("%dx%d"), *x, *y);
        SendMessage(hdb, WM_SETTEXT, 0, (LPARAM)buf);
        
        return TRUE;
    }else{
        return FALSE;
    }
}

void ins_size_list(HWND hdb, int x, int y, BOOL sel)
{
    TCHAR buf[64];
    LRESULT lr;
    
    StringCbPrintf(buf, sizeof(buf), TEXT("%dx%d"), x, y);
    
    //܂݂Ȃꍇǉ
    lr = SendMessage(hdb, CB_FINDSTRING, (WPARAM)-1, (LPARAM)buf);
    if(CB_ERR == lr){
        //𒴂ꍇ͈폜
        LRESULT cnt = SendMessage(hdb, CB_GETCOUNT, 0, 0);
        if(cnt >= NUM_LIST_MAX){
            SendMessage(hdb, CB_DELETESTRING, 0, 0);
        }
        
        lr = SendMessage(hdb, CB_ADDSTRING, 0, (LPARAM)buf);
        if(lr != CB_ERR && lr != CB_ERRSPACE){
            SendMessage(hdb, CB_SETITEMDATA, lr, (LPARAM)MAKELONG(x, y));
        }
    }
    
    //vꂽꍇ͑I
    if(sel && CB_ERR != lr){
        SendMessage(hdb, CB_SETCURSEL, lr, 0);
    }
}

void load_size_list(HWND hdb, FILTER *fp)
{
    int i,c,d;
    char buf[64];
    
    for(i=0; i<NUM_LIST_MAX; ++i){
        StringCbPrintfA(buf, sizeof(buf), "size_%02d", i);
        c = fp->exfunc->ini_load_int(fp, buf, 0);
        if(c == 0){
            break;
        }
        
        //f[^}
        d = abs(c);
        ins_size_list(hdb, LOWORD(d), HIWORD(d), c < 0);
    }
    
    if(i == 0){ //ݒ肪̏ꍇ
        ins_size_list(hdb, 640, 480, TRUE);
    }
}

void save_size_list(HWND hdb, FILTER *fp)
{
    int i;
    LRESULT cnt,sel,r;
    char buf[64];
    
    cnt = SendMessage(hdb, CB_GETCOUNT, 0, 0);
    sel = SendMessage(hdb, CB_GETCURSEL, 0, 0);
    cnt = min(cnt, NUM_LIST_MAX);
    
    for(i=0; i<cnt; ++i){
        StringCbPrintfA(buf, sizeof(buf), "size_%02d", i);
        r = SendMessage(hdb, CB_GETITEMDATA, i, 0);
        fp->exfunc->ini_save_int(fp, buf, (i==sel) ? -r : r);
    }
}

void get_font(void)
{
    NONCLIENTMETRICS ncm = { sizeof(NONCLIENTMETRICS), };
#if(WINVER >= 0x0600)
    ncm.cbSize = offsetof(NONCLIENTMETRICS, iPaddedBorderWidth);
#endif /* WINVER >= 0x0600 */
    
    if(h_font){
        return;
    }
    
    if(SystemParametersInfo(SPI_GETNONCLIENTMETRICS, ncm.cbSize, &ncm, 0)){
        h_font = CreateFontIndirect(&ncm.lfMessageFont);
    }
    
    //fallback
    if(!h_font){
        h_font = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
    }
}

void subclass_edit(void)
{
    COMBOBOXINFO cbi = { sizeof(COMBOBOXINFO), };
    
    if(GetComboBoxInfo(h_ddbox, &cbi)){
        //GfBbg̈TuNX
        h_edit = cbi.hwndItem;
        orig_edit_proc =
            (WNDPROC)SetWindowLongPtr(h_edit, GWL_WNDPROC, (LONG_PTR)ddb_edit_proc);
    }
}

void clear_handle(void)
{
    h_btn = h_ddbox = h_edit = NULL;
    h_font = NULL;
    orig_edit_proc = NULL;
}

LRESULT CALLBACK ddb_edit_proc(HWND h, UINT m, WPARAM w, LPARAM l)
{
    switch(m){
      case WM_CHAR:
        if(w == VK_RETURN){
            SendMessage(h_btn, BM_CLICK, 0, 0);
            return 0;
        }else if(w >= '0' && w <= '9'){
        }else if(w == 'x' || w == '*'){
        }else if(!isgraph(w)){
        }else{
            MessageBeep((UINT)-1);
            return 0;
        }
        break;
      default:
        break;
    }

    return CallWindowProc(orig_edit_proc, h, m, w, l); 
}


